function results = PreAvg_JLZ(Y,J,T,knl,hnl,knpl)

N                = length(Y)-1;
% phi_0            =          1/12;
% Phi_00           =          151/80640;
% Phi_01           =          1/96;
% Phi_11           =          1/6;
kn               =          knl;
kn_p             =          knpl;

theta            =          0.8;
rho              =          0.7;
hn               =          round(hnl*sqrt(N));
hn_p             =          round(hnl*N^rho);

g                =          @(x) min(x,(1-x));
g_bar            =          zeros(hn,1); 

for k=1:hn
    g_bar(k)     =          g(k/hn)-g((k-1)/hn); 
end
phi_n_0          =          sum(g((0:hn)/hn).^2)/hn;


phi_bar          =          zeros(kn_p+1,1); 
for k=1:kn_p+1
    phi_bar(k)   =          hn*sum(g_bar(k:hn).*g_bar(1:hn-k+1));
end

g_bar_p          =          zeros(hn_p,1);
for k=1:hn_p
    g_bar_p(k)   =          g(k/hn_p)-g((k-1)/hn_p);
end



Y_bar            =          movavg(Y(1:length(Y)),'simple',kn);%tsmovavg(Y(1:length(Y)),'s',kn,1);
Y_bar(1:kn-1)    =          [];

U                =          zeros(kn_p+1,1);
for k=0:kn_p
    ind          =          1:N+1-5*kn;
    U(k+1)       =          sum((Y(ind)-Y_bar(2*kn+ind)).*(Y(k+ind)-Y_bar(4*kn+ind)));
end

J2               =          N+1-hn;
Y_bar_hn         =          zeros(J2,1);
for k            =          1:J2
    Y_bar_hn(k)  =          -sum(g_bar.*Y(k+1:k+hn-1+1)); 
end

IV               =          sum(Y_bar_hn.^2)/(hn*phi_n_0)-1/(hn^2*phi_n_0)*(phi_bar(1)*U(1) + 2*sum(phi_bar(2:end).*U(2:end)));



ln               =          round(theta*N^(2/3));

J3               =          N+1 - ln;
Y_bar_ln         =          zeros(J3,1);

g_bar_ln            =          zeros(ln,1); 

for k=1:ln
    g_bar_ln(k)     =          g(k/ln)-g((k-1)/ln); 
end

for k            =          1:J3
    Y_bar_ln(k)  =          -sum(g_bar_ln.*Y(k+1:k+ln-1+1)); 
end
Quarticity       =         sum(Y_bar_ln(1:J3-ln).^2.*Y_bar_ln(ln+1:J3).^2)./phi_n_0^2/T/ln^2*N;



R_est  =  zeros(J+1,1);
U_0    =  zeros(J+1,1);

for j  =  0:J
    mu =  j;
    ind=  1:N+1-mu-2*2*kn;
    U_0(j+1)  = sum((Y(ind)-Y_bar(mu+kn+ind)).*(Y(j+ind)-Y_bar(mu+3*kn+ind)));
    R_est(j+1)= U_0(j+1)/length(ind);
end

r_est   =   R_est/R_est(1);

%% Std for Noises

UU_1=zeros(kn_p+1,J+1); % 
UU_2=zeros(kn_p+1,J+1); % 
UU_3=zeros(kn_p+1,J+1); % 
UU_4=zeros(kn_p+1,J+1); %

for m=0:kn_p
    for j=0:J
        mu=j+m;
        ind=1:N+1-mu-2*4*kn;
        UU_1(m+1,j+1)=sum((Y(ind)-Y_bar(mu+kn+ind)).*(Y(j+ind)-Y_bar(mu+3*kn+ind)).*(Y(m+ind)-Y_bar(mu+5*kn+ind)).*(Y(j+m+ind)-Y_bar(mu+7*kn+ind)));
        UU_2(m+1,j+1)=sum((Y(m+ind)-Y_bar(mu+kn+ind)).*(Y(j+m+ind)-Y_bar(mu+3*kn+ind)).*(Y(ind)-Y_bar(mu+5*kn+ind)).*(Y(j+ind)-Y_bar(mu+7*kn+ind)));  
        UU_3(m+1,j+1)=sum((Y(ind)-Y_bar(mu+kn+ind)).*(Y(j+ind)-Y_bar(mu+3*kn+ind)).*(Y(m+ind)-Y_bar(mu+5*kn+ind)).*(Y(m+ind)-Y_bar(mu+7*kn+ind)));  
        UU_4(m+1,j+1)=sum((Y(m+ind)-Y_bar(mu+kn+ind)).*(Y(j+m+ind)-Y_bar(mu+3*kn+ind)).*(Y(ind)-Y_bar(mu+5*kn+ind)).*(Y(ind)-Y_bar(mu+7*kn+ind)));  
    end
end

U_bar_1=zeros(J+1,1); % 
U_bar_2=zeros(J+1,1); %

for j=0:J
    mu=j;
    mu_pp=j+j;
    
    ind=1:N+1-mu_pp-(2*4+1)*kn;

    U_bar_1(j+1)=sum((Y(ind)-Y_bar(mu+kn+ind)).*(Y(j+ind)-Y_bar(mu+3*kn+ind)).*(Y(mu+(2*2+1)*kn+0+ind)-Y_bar(mu_pp+(2*2+1)*kn+kn+ind)).*(Y(mu+(2*2+1)*kn+j+ind)-Y_bar(mu_pp+(2*2+1)*kn+3*kn+ind)));
    U_bar_2(j+1)=sum((Y(ind)-Y_bar(mu+kn+ind)).*(Y(j+ind)-Y_bar(mu+3*kn+ind)).*(Y(mu+(2*2+1)*kn+0+ind)-Y_bar(mu+(2*2+1)*kn+kn+ind)).*(Y(mu+(2*2+1)*kn+0+ind)-Y_bar(mu+(2*2+1)*kn+3*kn+ind)));
end

S=zeros(J+1,1); % S[0,j,0,j]
Bza=zeros(J+1,1); % Bza[0,j,0,j]

S_1=zeros(J+1,1); % S[0,j,0,0]
Bza_1=zeros(J+1,1); % Bza[0,j,0,0]
sigma_r=ones(J,1); % 

j=0;
S(j+1)=(sum(UU_1(:,j+1))+sum(UU_2(:,j+1))-UU_1(1,j+1))-(2*kn_p+1)*U_bar_1(j+1);
Bza(j+1)=S(j+1)/N+U_bar_1(j+1)/N-R_est(j+1)^2;

S_1(j+1)=(sum(UU_3(:,j+1))+sum(UU_4(:,j+1))-UU_3(1,j+1))-(2*kn_p+1)*U_bar_2(j+1);
Bza_1(j+1)=S_1(j+1)/N+U_bar_2(j+1)/N-R_est(1)*R_est(j+1);


for j=1:J
    S(j+1)=(sum(UU_1(:,j+1))+sum(UU_2(:,j+1))-UU_1(1,j+1))-(2*kn_p+1)*U_bar_1(j+1);
    Bza(j+1)=S(j+1)/N+U_bar_1(j+1)/N-R_est(j+1)^2;

    S_1(j+1)=(sum(UU_3(:,j+1))+sum(UU_4(:,j+1))-UU_3(1,j+1))-(2*kn_p+1)*U_bar_2(j+1);
    Bza_1(j+1)=S_1(j+1)/N+U_bar_2(j+1)/N-R_est(1)*R_est(j+1);
    sigma_r(j)=(R_est(1)^2*Bza(j+1)+R_est(j+1)^2*Bza(1)-2*R_est(1)*R_est(j+1)*Bza_1(j+1))/(R_est(1)^4);
end


results.R    = R_est/T;
results.Rstd = 1./sqrt(N./abs(Bza))/T;
results.rstd = 1./sqrt(N./abs(sigma_r));
results.r = r_est;
results.Pvg = IV/T;
results.Quarticity = Quarticity;