function fFTRK = function_FTRK_PZ_multi_all_bandwidths( fdim,fretvec,fH,fc)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Flat-top realized kernel estimation

%fdim: number of assets.
%fretvec: Matrix of log-returns.
%fH: Bandwidth for the FTRK estimator.
  
fgamma0       = zeros(fdim,fdim);
fgammaplus    = zeros(fdim,fdim);
fgammaminus   = zeros(fdim,fdim);
  
  
for fh=0:fH+floor(fc*fH)-1
    
    fx          = fh/fH;
    
    % Flat-top Parzen Window
    
    if (fx <= fc)
        fweight     = 1;  
    end
    if (fx > fc)
        fx1         = fx-fc;
      
        if ((fx1-0.5)<=0)
            fweight   = 1-6*fx1^2+6*fx1^3;
        end
        if ((fx1-0.5)>0)
            fweight   = 2*(1-fx1)^3; 
        end
      
    end
    
    fgammaplush     = zeros(fdim,fdim);
    fgammaminush    = zeros(fdim,fdim);
    
    
    for fi=fh:size(fretvec,1)-1
          
        if (fh==0)
            fgamma0         = fgamma0 + fretvec(fi+1,:)'*fretvec(fi+1,:);  
        end
      
        if (fh>0)        
            fgammaplush     = fgammaplush    + fretvec(fi+1,:)'*fretvec(fi+1-fh,:);
            fgammaminush    = fgammaminush   + fretvec(fi+1-fh,:)'*fretvec(fi+1,:);
        end
      
    end
    
    fgammaplus      = fgammaplus  + fweight*fgammaplush;
    fgammaminus     = fgammaminus + fweight*fgammaminush;
    
end
  
  fFTRK     = fgamma0 + fgammaplus + fgammaminus;
  
end