function [C4,D4,B1,B2,B3] = quarticity_func_general(Y,T,theta)

N                =          length(Y)-1;
g                =          @(x) min(x,(1-x));
phi_0            =          1/12;
ln               =          round(theta*N^(2/3));
lnp              =          3*ln;
J3               =          N+1 - ln;
Y_bar_ln         =          zeros(J3,1);
g_bar_ln         =          zeros(ln,1); 

for k=1:ln
    g_bar_ln(k)  =          g(k/ln)-g((k-1)/ln); 
end

for k            =          1:J3
    Y_bar_ln(k)  =          -sum(g_bar_ln.*Y(k+1:k+ln-1+1));
end


ubartemp         =          2.5.*sqrt(sum(Y_bar_ln.^2)/T/ln./phi_0).*(ln*(T/N)).^(0.47);
th               =          sum((Y_bar_ln.^2.*(abs(Y_bar_ln)<ubartemp)))/T/ln./phi_0;        

ubar             =          3.*sqrt(th).*(ln*(T/N)).^(0.47);     
   
C4               =          sum(Y_bar_ln(1:J3-ln).^2.*Y_bar_ln(ln+1:J3).^2.*(abs(Y_bar_ln(1:J3-ln))<ubar).*(abs(Y_bar_ln(ln+1:J3))<ubar))./phi_0^2/T^2/ln^2*N;
    

chat = zeros(J3-lnp,1);
    
    for i        =          1:J3-lnp
    
        chat(i)  =          1/ln/lnp/T*N/phi_0*sum((Y_bar_ln(i:i+lnp).^2.*(abs(Y_bar_ln(i:i+lnp))<ubar)));

    end
    
    
D4               =          sum(Y_bar_ln((lnp+1):(J3-lnp)).^2.*(abs(Y_bar_ln((lnp+1):(J3-lnp)))>ubar).*(chat((lnp+1):(J3-lnp))+chat((1):(J3-2*lnp))))/T/ln/phi_0; 

 y = diff(Y); 
B1 = 1/N*sum(y(1:J3-lnp).^2.*chat(1:J3-lnp));
B2 = 1/2/T/ln/phi_0*sum((y(1:N-lnp).^2+y(lnp+1:N).^2).*Y_bar_ln(1:N-lnp).^2.*(abs(Y_bar_ln(1:(N-lnp)))>ubar));
B3 = 1/4/N*sum(y(1:N-lnp).^2.*y(1+lnp:N).^2);
    
   